## socket 1.1

=== Makefile ===
# Makefile for Socket
#
# $Header: Makefile[1.23] Wed Sep  9 19:03:26 1992 nickel@cs.tu-berlin.de proposed $
#

### adjust these to your taste
### This is set up to install socket as /usr/local/bin/socket and
### socket.1 in /usr/local/man/man1/socket.1
### Make sure the target directories exist before doing a "make install".

INSTALLBASE = /usr/local
INSTALLBINPATH = $(INSTALLBASE)/bin
INSTALLBINMODE = 755
INSTALLMANPATH = $(INSTALLBASE)/man
INSTALLMANMODE = 444
CC = cc
CFLAGS  = $(SWITCHES) -O
LDFLAGS = $(SWITCHES) -s

### You may need to uncomment some lines below for your operating
### system:

### 4.3 BSD:
# SWITCHES = -DNOSETSID

### HP-UX:
# SYSLIBS  = -lBSD

### ISC 3.0:
# SYSLIBS  = -linet -lcposix
# SWITCHES = -DISC

### System V Rel. 4:
# SYSLIBS  = -lc -lsocket -lnsl -L/usr/ucblib -lucb
# SWITCHES = -I/usr/ucbinclude

### Sequent:
# SYSLIBS  = -lseq
# SWITCHES = -Dstrrchr=rindex -DSEQUENT -DNOSETSID
### (I have been reported troubles with the "installmanuals" target on
### a Sequent, so you might have to copy the manual page yourself.)

### CDC 4680 EP/IX: (I know it *has* setsid(2), but not with bsd43)
# SWITCHES = -systype bsd43 -DNOSETSID



### It should not be necessary to change anything below this line.
##################################################################

MAKE = make
SHELL = /bin/sh
BASE = /home/stone/nickel/src
NODEPATH = socket
NODENAME = "Socket"
TARGET = socket
VERSIONFILE = 	so_release.c
VERSIONOBJECT =	so_release.o
PROGSOURCES = socket.c siglist.c io.c utils.c socketp.c
SOURCES = BLURB README COPYRIGHT INSTALL CHANGES \
	socket.1 \
	$(PROGSOURCES) \
	rfinger.sh fingerd.sh
HEADERS = globals.h patchlevel.h
MANUALS = $(MAN1)
MAN1 = socket.1
COMPONENTS = $(SOURCES) $(HEADERS) $(MANUALS) Makefile Dependencies
OBJECTS = $(VERSIONOBJECT) socket.o siglist.o io.o utils.o socketp.o

all: +all $(ALLTARGETS)

targets: $(TARGET)

$(TARGET): $(LOCALLIBS) $(OBJECTS)
	$(CC) $(LDFLAGS) -o $(TARGET) $(OBJECTS) $(LOCALLIBS) $(SYSLIBS)

tags: TAGS
TAGS: $(PROGSOURCES) $(HEADERS)
	etags $(PROGSOURCES) $(HEADERS)

installtargets: $(INSTALLBINPATH)/$(TARGET) installmanuals

$(INSTALLBINPATH)/$(TARGET): $(TARGET)
	@-echo "installing $(TARGET) in $(INSTALLBINPATH)"; \
	if [ -f $(INSTALLBINPATH)/$(TARGET) ] && \
	   [ ! -w $(INSTALLBINPATH)/$(TARGET) ]; \
	then \
	  chmod u+w $(INSTALLBINPATH)/$(TARGET); \
	fi; \
	cp $(TARGET) $(INSTALLBINPATH)/$(TARGET); \
	chmod $(INSTALLBINMODE) $(INSTALLBINPATH)/$(TARGET)

installmanuals: $(MANUALS)
	@-_manuals="$(MAN1)"; \
	for i in $$_manuals; \
	do \
	  echo "installing $$i in $(INSTALLMANPATH)/man1"; \
	  if [ -f $(INSTALLMANPATH)/man1/$$i ] && \
	     [ ! -w $(INSTALLMANPATH)/man1/$$i ]; \
	  then \
	    chmod u+w $(INSTALLMANPATH)/man1/$$i; \
	  fi; \
	  cp $$i $(INSTALLMANPATH)/man1/$$i; \
	  chmod $(INSTALLMANMODE) $(INSTALLMANPATH)/man1/$$i; \
	done

doclean:
	rm -f $(TARGET) $(ALIASES) $(OBJECTS) core *~

##
## following internals of shapeTools Release Management System

subsystems: # none

install: +install $(ALLTARGETS)

clean: +clean $(ALLTARGETS)

+all:
	@-if [ -n "$(ALLTARGETS)" ]; \
	then : ; \
	else \
	  $(MAKE) ALLTARGETS="subsystems targets" MAINTARGET=all \
		BASE=$(BASE) \
		SWITCHES="$(SWITCHES)" \
		INSTALLBASE=$(INSTALLBASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		SYSLIBS="$(SYSLIBS)" all; \
	fi

+install:
	@-if [ -n "$(ALLTARGETS)" ]; \
	then : ; \
	else \
	  $(MAKE) ALLTARGETS="subsystems installtargets" \
		MAINTARGET=install \
		BASE=$(BASE) \
		SWITCHES="$(SWITCHES)" \
		INSTALLBASE=$(INSTALLBASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		SYSLIBS="$(SYSLIBS)" install; \
	fi

+clean:
	@-if [ -n "$(ALLTARGETS)" ]; \
	then : ; \
	else \
	  $(MAKE) ALLTARGETS="subsystems doclean" MAINTARGET=clean \
		BASE=$(BASE) \
		SWITCHES="$(SWITCHES)" \
		INSTALLBASE=$(INSTALLBASE) \
		INSTALLBINPATH=$(INSTALLBINPATH) \
		INSTALLBINMODE=$(INSTALLBINMODE) \
		INSTALLMANPATH=$(INSTALLMANPATH) \
		INSTALLMANMODE=$(INSTALLMANMODE) \
		INCLUDEPATH=$(INCLUDEPATH) \
		MAKE="$(MAKE)" \
		SHELL="$(SHELL)" \
		CC="$(CC)" \
		CFLAGS="$(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		SYSLIBS="$(SYSLIBS)" clean; \
	fi

=== debian/changelog ===
socket (1.1-10.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update debhelper compat to 7. (closes: #965823)
  * Add missing rules targets. (closes: #999271)
  * Enable cross build. (closes: #922373)
  * Convert to source format 3.0 (quilt).

 -- Bastian Germann <bage@debian.org>  Fri, 19 May 2023 13:56:24 +0200

socket (1.1-10) unstable; urgency=low

  * (Re-) Adopting the package. (closes: #487341)
  * Applied excellent patch from Andras Pal <apal@cfa.harvard.edu>
    + Fixed some missing headers
    + (hopefully) complete support for UNIX domain sockets

 -- LENART Janos <ocsi@debian.org>  Tue, 14 Apr 2009 09:49:04 +0200

socket (1.1-9) unstable; urgency=low

  * QA upload.
    + Set maintainer to Debian QA Group <packages@qa.debian.org>.
  * Fix typo in manpage. (Closes: #278350).
  * Makefile: Remove -s from LDFLAGS. (Closes: #438035).
  * Move DH_COMPAT to debian/compat and set to 5.
  * Bump Standards Version to 3.8.0.

 -- Barry deFreese <bdefreese@debian.org>  Fri, 05 Dec 2008 21:51:52 -0500

socket (1.1-8) unstable; urgency=low

  * Fixed errno definiation.                        (closes: Bug#218938)
  * Now local bind address can be specified.
    Thanks: Oscar Martin Gonzalez <idi@xolido.com>
  * Upgrade Standards-Version.

 -- Lenart Janos <ocsi@debian.org>  Mon,  3 Nov 2003 21:35:57 +0100

socket (1.1-7) unstable; urgency=medium

  * Data corruption bug fixed locally. Thanks to Wessel Dankers for
    providing a very nice patch.                    (closes: Bug#173974)
  * 32bit specific long's replaced with uint32_t's. (closes: Bug#173967)
  * Emacs-thingy removed from this changelog.
  * This is the last release of the 1.1 version. 2.0 coming soon.

 -- Lenart Janos <ocsi@debian.org>  Tue,  7 Jan 2003 00:08:55 +0100

socket (1.1-6) unstable; urgency=low

  * Adopted package.                                 (closes: Bug#99733)
  * Fully redebianized; prepared for building with debhelper version 3.
    Patches agains the source were applied, changelog kept for historic
    reasons (only cosmetically changed). Manpages are now installed by
    debhelper, and not the Makefile in source. Hmm. That's all.

 -- Lenart Janos <ocsi@debian.org>  Sun, 10 Jun 2001 19:06:03 +0200

socket (1.1-5.1) unstable; urgency=low

  * Bugsquash party NMU.
  * Build with and build-depend on new debmake, in order to move to /usr
    /share/doc and /usr/share/man    (closes: Bug#90423, #91071, #91665)
  * Updated to policy version 3.1.1 so that build dependencies are
    defined.
  * Get dpkg-gencontrol to include the section and priority.
  * Raised priority to optional to match the override file.

 -- Colin Watson <cjwatson@debian.org>  Sat, 14 Apr 2001 00:44:11 +0100

socket (1.1-5) frozen unstable; urgency=low

  * rebuild with latest debmake (fixes lintian warnings)
  * updated standards-version

 -- Peter Tobias <tobias@et-inf.fho-emden.de>  Mon, 30 Mar 1998 00:39:57 +0200

socket (1.1-4) unstable; urgency=low

  * libc6 version

 -- Peter Tobias <tobias@et-inf.fho-emden.de>  Sun, 14 Sep 1997 11:56:56 +0200

socket (1.1-3) unstable; urgency=low

  * minor glibc fix

 -- Peter Tobias <tobias@et-inf.fho-emden.de>  Thu, 19 Jun 1997 10:01:40 +0200

socket (1.1-2) unstable; urgency=low

  * changed name of upstream changelog file

 -- Peter Tobias <tobias@et-inf.fho-emden.de>  Sun, 25 May 1997 00:27:03 +0200

socket (1.1-1) unstable; urgency=low

  * Initial Release.

 -- Peter Tobias <tobias@et-inf.fho-emden.de>  Tue, 14 Jan 1997 01:57:44 +0100

=== debian/control ===
Source: socket
Section: net
Priority: optional
Maintainer: LENART Janos <ocsi@debian.org>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.8.1

Package: socket
Architecture: any
Depends: ${shlibs:Depends}
Description: Multi purpose socket tool
 The socket program is a simple tool for socket based connections. It
 can be used to create simple daemons (in both standalone and inetd
 mode), to connect to other daemons or to redirect ports.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for socket by Lenart Janos.
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: configure-stamp build-arch build-indep
build-arch:
	dh_testdir
	dh_auto_build
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch configure-stamp
	$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs usr/bin
	$(MAKE) install DESTDIR=$(CURDIR)/debian/socket

# Build architecture-independent files here.
build-indep:
binary-indep: build-indep install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build-arch install
	dh_testdir
	dh_testroot
	dh_installdocs README
	dh_installman socket.1
	dh_installchangelogs CHANGES
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build-indep build clean binary-indep binary-arch binary install configure

## socket demo

=== Makefile ===
#*******************************************************************************
# include ZTE application makefile
#*******************************************************************************
include $(zte_app_mak)

##############USER COMIZE BEGIN################

EXEC = socket_demo
OBJS = $(patsubst %.c,%.o,$(wildcard *.c))

CFLAGS += -I.
CFLAGS += -I$(zte_app_path)/include


CFLAGS += -g
CFLAGS += -g -Werror=implicit-function-declaration

LDLIBS += -lpthread

#*******************************************************************************
# targets
#*******************************************************************************
all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ -Wl,--start-group $(LDLIBS) -Wl,--end-group
	@cp $@ $@.elf

romfs:
	$(ROMFSINST) $(EXEC) /sbin/$(EXEC)

clean:
	-rm -f $(EXEC) *.elf *.gdb *.o

## socket faq

=== socket-faq-examples/Makefile ===
# Uncomment the following line for Solaris
# C_LINK = -lsocket -lnsl

# Uncomment this for SCO.  (Note, this has only been reported to work with
# Revision 3.2.4 with the "SCO TCP/IP Development System" package installed.
# Please let me know if you have any other SCO success stories.
# C_LINK = -lsocket

# Comment the following line if you are not using the gnu c compiler
# C_ARGS = -Wall

# You might have to change this if your c compiler is not cc
CC = cc

# You shouldn't need to make any more changes below this line.

all:	tcpclient tcpserver udpclient udpserver nbserver

clean:
	rm -f *.o

distclean:	clean
	rm -f tcpclient tcpserver udpclient udpserver nbserver

tcpclient:	tcpclient.o sockhelp.o
	$(CC) -o tcpclient tcpclient.o sockhelp.o $(C_LINK)

tcpserver:	tcpserver.o sockhelp.o
	$(CC) -o tcpserver tcpserver.o sockhelp.o $(C_LINK)

tcpclient.o:	tcpclient.c
	$(CC) $(C_ARGS) $(C_LINK) -c tcpclient.c

tcpserver.o:	tcpserver.c
	$(CC) $(C_ARGS) -c tcpserver.c

sockhelp.o:	sockhelp.c
	$(CC) $(C_ARGS) $(C_LINK) -c sockhelp.c

udpserver:	udpserver.o sockhelp.o
	$(CC) -o udpserver udpserver.o sockhelp.o $(C_LINK)

udpclient:	udpclient.o sockhelp.o
	$(CC) -o udpclient udpclient.o sockhelp.o $(C_LINK)

nbserver:	nbserver.o sockhelp.o
	$(CC) -o nbserver nbserver.o sockhelp.o $(C_LINK)

udpserver.o:	udpserver.c
	$(CC) $(C_ARGS)  -c udpserver.c

nbserver.o:	nbserver.c
	$(CC) $(C_ARGS)  -c nbserver.c

udpclient.o:	udpclient.c
	$(CC) $(C_ARGS) -c udpclient.c

reuseaddr:	reuseaddr.o sockhelp.o
	$(CC) -o reuseaddr reuseaddr.o sockhelp.o $(C_LINK)

reuseaddr.o:	reuseaddr.c
	$(CC) $(C_ARGS) -c reuseaddr.c

## socket vmnet-1.1.3

=== Makefile ===
# PREFIX should be only writable by the root to avoid privilege escalation with launchd or sudo
PREFIX ?= /opt/socket_vmnet

export SOURCE_DATE_EPOCH ?= $(shell git log -1 --pretty=%ct)
# https://reproducible-builds.org/docs/archives/
TAR ?= gtar --sort=name --mtime="@$(SOURCE_DATE_EPOCH)" --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime
TOUCH ?= gtouch -d @$(SOURCE_DATE_EPOCH)
# Not necessary to use GNU's gzip
GZIP ?= gzip -9 -n
DIFFOSCOPE ?= diffoscope
STRIP ?= strip

CFLAGS ?= -O3

VERSION ?= $(shell git describe --match 'v[0-9]*' --dirty='.m' --always --tags)
VERSION_TRIMMED := $(VERSION:v%=%)

CFLAGS += -DVERSION=\"$(VERSION)\"

LDFLAGS ?=
VMNET_LDFLAGS = -framework vmnet

# ARCH support arm64 and x86_64
ARCH ?=

ifneq (,$(findstring arm64,$(ARCH)))
	HOST ?= --host arm-apple-darwin
	CFLAGS += -arch arm64
else ifneq (,$(findstring x86_64,$(ARCH)))
	HOST ?= --host x86_64-apple-darwin
	CFLAGS += -arch x86_64
endif

# Interface name for bridged mode. Empty value (default) disables bridged mode.
BRIDGED ?=

all: socket_vmnet socket_vmnet_client

%.o: %.c *.h
	$(CC) $(CFLAGS) -c $< -o $@

socket_vmnet: $(patsubst %.c, %.o, $(wildcard *.c))
	$(CC) $(CFLAGS) -o $@ $(LDFLAGS) $(VMNET_LDFLAGS) $^

socket_vmnet_client: $(patsubst %.c, %.o, $(wildcard client/*.c))
	$(CC) $(CFLAGS) -o $@ $(LDFLAGS) $^

install.bin: socket_vmnet socket_vmnet_client
	mkdir -p "$(DESTDIR)/$(PREFIX)/bin"
	cp -a socket_vmnet "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet"
	cp -a socket_vmnet_client "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet_client"
	$(STRIP) "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet"
	$(STRIP) "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet_client"

install.doc: README.md LICENSE launchd etc_sudoers.d
	mkdir -p "$(DESTDIR)/$(PREFIX)/share/doc/socket_vmnet"
	cp -a $? "$(DESTDIR)/$(PREFIX)/share/doc/socket_vmnet"

install.launchd.plist: launchd/*.plist
	sed -e "s@/opt/socket_vmnet@$(PREFIX)@g" launchd/io.github.lima-vm.socket_vmnet.plist > "$(DESTDIR)/Library/LaunchDaemons/io.github.lima-vm.socket_vmnet.plist"

ifneq ($(BRIDGED),)
	sed -e "s@/opt/socket_vmnet@$(PREFIX)@g" -e "s/en0/$(BRIDGED)/g" launchd/io.github.lima-vm.socket_vmnet.bridged.en0.plist > "$(DESTDIR)/Library/LaunchDaemons/io.github.lima-vm.socket_vmnet.bridged.$(BRIDGED).plist"
endif

define load_launchd
	# Hint: try `launchctl enable system/$(1)` if the `launchctl bootstrap` command below fails
	launchctl bootstrap system "$(DESTDIR)/Library/LaunchDaemons/$(1).plist"
	launchctl enable system/$(1)
	launchctl kickstart -kp system/$(1)
endef

install.launchd: install.launchd.plist
	$(call load_launchd,io.github.lima-vm.socket_vmnet)
ifneq ($(BRIDGED),)
	$(call load_launchd,io.github.lima-vm.socket_vmnet.bridged.$(BRIDGED))
endif

install: install.bin install.doc install.launchd

.PHONY: uninstall.bin
uninstall.bin:
	rm -f "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet"
	rm -f "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet_client"

.PHONY: uninstall.doc
uninstall.doc:
	rm -rf "$(DESTDIR)/$(PREFIX)/share/doc/socket_vmnet"

define unload_launchd
	launchctl bootout system "$(DESTDIR)/Library/LaunchDaemons/$(1).plist" || true
endef

.PHONY: uninstall.launchd
uninstall.launchd:
	$(call unload_launchd,io.github.lima-vm.socket_vmnet)
ifneq ($(BRIDGED),)
	$(call unload_launchd,io.github.lima-vm.socket_vmnet.bridged.$(BRIDGED))
endif

uninstall.launchd.plist: uninstall.launchd
	rm -f "$(DESTDIR)/Library/LaunchDaemons/io.github.lima-vm.socket_vmnet.plist"
ifneq ($(BRIDGED),)
	rm -f "$(DESTDIR)/Library/LaunchDaemons/io.github.lima-vm.socket_vmnet.bridged.$(BRIDGED).plist"
endif

.PHONY: uninstall.run
uninstall.run:
	rm -f /var/run/socket_vmnet*

uninstall: uninstall.launchd.plist uninstall.doc uninstall.bin uninstall.run

.PHONY: clean
clean:
	rm -f socket_vmnet socket_vmnet_client *.o client/*.o

define make_artifacts
	$(MAKE) clean
	rm -rf _artifacts/$(1)
	$(MAKE) ARCH=$(1) DESTDIR=_artifacts/$(1) install.bin install.doc
	file -bp _artifacts/$(1)/$(PREFIX)/bin/socket_vmnet | grep -q "Mach-O 64-bit executable $(1)"
	$(TAR) -C _artifacts/$(1) -cf _artifacts/socket_vmnet-$(VERSION_TRIMMED)-$(1).tar ./
	$(GZIP) _artifacts/socket_vmnet-$(VERSION_TRIMMED)-$(1).tar
	rm -rf _artifacts/$(1)
	$(MAKE) clean
endef

.PHONY: artifacts
artifacts:
	rm -rf _artifacts
	$(call make_artifacts,x86_64)
	$(call make_artifacts,arm64)
	sw_vers | tee _artifacts/build-env.txt
	echo --- >> _artifacts/build-env.txt
	pkgutil --pkg-info=com.apple.pkg.CLTools_Executables | tee -a _artifacts/build-env.txt
	echo --- >> _artifacts/build-env.txt
	$(CC) --version | tee -a _artifacts/build-env.txt
	(cd _artifacts ; shasum -a 256 *) > SHA256SUMS
	mv SHA256SUMS _artifacts/SHA256SUMS
	$(TOUCH) _artifacts/* _artifacts

.PHONY: test.repro
test.repro:
	rm -rf _artifacts.0 _artifacts.1
	$(MAKE) artifacts
	mv _artifacts _artifacts.0
	$(MAKE) artifacts
	mv _artifacts _artifacts.1
	$(DIFFOSCOPE) _artifacts.0/ _artifacts.1/

## socket vmnet-1.2.1

=== Makefile ===
--- 
+++ 
@@ -1,16 +1,23 @@
 # PREFIX should be only writable by the root to avoid privilege escalation with launchd or sudo
 PREFIX ?= /opt/socket_vmnet
 
+# DEBUG=1 is known to break reproducible builds
+DEBUG ?=
+
 export SOURCE_DATE_EPOCH ?= $(shell git log -1 --pretty=%ct)
-# https://reproducible-builds.org/docs/archives/
-TAR ?= gtar --sort=name --mtime="@$(SOURCE_DATE_EPOCH)" --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime
-TOUCH ?= gtouch -d @$(SOURCE_DATE_EPOCH)
+SOURCE_DATE_EPOCH_ISO8601 := $(shell date -u -Iseconds -r $(SOURCE_DATE_EPOCH) | sed -e s/+00:00/Z/)
+
+TAR ?= tar --uid=0 --gid=0 --numeric-owner
+TOUCH ?= touch -d $(SOURCE_DATE_EPOCH_ISO8601)
 # Not necessary to use GNU's gzip
 GZIP ?= gzip -9 -n
 DIFFOSCOPE ?= diffoscope
 STRIP ?= strip
 
-CFLAGS ?= -O3
+CFLAGS ?= -O3 -Wall -Wextra -pedantic
+ifeq ($(DEBUG),1)
+	CFLAGS += -g
+endif
 
 VERSION ?= $(shell git describe --match 'v[0-9]*' --dirty='.m' --always --tags)
 VERSION_TRIMMED := $(VERSION:v%=%)
@@ -46,6 +53,7 @@
 	$(CC) $(CFLAGS) -o $@ $(LDFLAGS) $^
 
 install.bin: socket_vmnet socket_vmnet_client
+	logger "Installing executables for socket_vmnet $(VERSION) in $(DESTDIR)/$(PREFIX)/bin"
 	mkdir -p "$(DESTDIR)/$(PREFIX)/bin"
 	cp -a socket_vmnet "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet"
 	cp -a socket_vmnet_client "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet_client"
@@ -53,6 +61,7 @@
 	$(STRIP) "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet_client"
 
 install.doc: README.md LICENSE launchd etc_sudoers.d
+	logger "Installing documentation for socket_vmnet $(VERSION) in $(DESTDIR)/$(PREFIX)/share/doc"
 	mkdir -p "$(DESTDIR)/$(PREFIX)/share/doc/socket_vmnet"
 	cp -a $? "$(DESTDIR)/$(PREFIX)/share/doc/socket_vmnet"
 
@@ -65,6 +74,7 @@
 
 define load_launchd
 	# Hint: try `launchctl enable system/$(1)` if the `launchctl bootstrap` command below fails
+	logger "Installing launchd service for socket_vmnet $(VERSION) in $(DESTDIR)/Library/LaunchDaemons/$(1).plist"
 	launchctl bootstrap system "$(DESTDIR)/Library/LaunchDaemons/$(1).plist"
 	launchctl enable system/$(1)
 	launchctl kickstart -kp system/$(1)
@@ -80,6 +90,7 @@
 
 .PHONY: uninstall.bin
 uninstall.bin:
+	logger "Uninstalling executables for socket_vmnet"
 	rm -f "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet"
 	rm -f "$(DESTDIR)/$(PREFIX)/bin/socket_vmnet_client"
 
@@ -88,6 +99,7 @@
 	rm -rf "$(DESTDIR)/$(PREFIX)/share/doc/socket_vmnet"
 
 define unload_launchd
+	logger "Uninstalling launchd service for socket_vmnet"
 	launchctl bootout system "$(DESTDIR)/Library/LaunchDaemons/$(1).plist" || true
 endef
 
@@ -119,7 +131,10 @@
 	rm -rf _artifacts/$(1)
 	$(MAKE) ARCH=$(1) DESTDIR=_artifacts/$(1) install.bin install.doc
 	file -bp _artifacts/$(1)/$(PREFIX)/bin/socket_vmnet | grep -q "Mach-O 64-bit executable $(1)"
-	$(TAR) -C _artifacts/$(1) -cf _artifacts/socket_vmnet-$(VERSION_TRIMMED)-$(1).tar ./
+	# BSD tar does not have `--mtime=TIMESTAMP` option
+	find _artifacts/$(1) -exec $(TOUCH) {} \;
+	# BSD tar does not have `--sort=name` option
+	(cd _artifacts/$(1) && find -s . -print0 | $(TAR) -cf ../socket_vmnet-$(VERSION_TRIMMED)-$(1).tar --null -n --files-from /dev/stdin)
 	$(GZIP) _artifacts/socket_vmnet-$(VERSION_TRIMMED)-$(1).tar
 	rm -rf _artifacts/$(1)
 	$(MAKE) clean

## socket wrapper-1.0.2

=== CMakeLists.txt ===
project(socket_wrapper C)

# Required cmake version
cmake_minimum_required(VERSION 2.8.5)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

set(APPLICATION_VERSION_MAJOR "1")
set(APPLICATION_VERSION_MINOR "0")
set(APPLICATION_VERSION_PATCH "2")

set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")

# SOVERSION scheme: CURRENT.AGE.REVISION
#   If there was an incompatible interface change:
#     Increment CURRENT. Set AGE and REVISION to 0
#   If there was a compatible interface change:
#     Increment AGE. Set REVISION to 0
#   If the source code was changed, but there were no interface changes:
#     Increment REVISION.
set(LIBRARY_VERSION "0.0.2")
set(LIBRARY_SOVERSION "0")

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/cmake/Modules
)

# add definitions
include(DefineCMakeDefaults)
include(DefinePlatformDefaults)
include(DefineCompilerFlags)
include(DefineInstallationPaths)
include(DefineOptions.cmake)
include(CPackConfig.cmake)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(src)

if (UNIT_TESTING)
  find_package(CMocka REQUIRED)
  include(AddCMockaTest)
  add_subdirectory(tests)
endif (UNIT_TESTING)

# pkg-config file
get_filename_component(SOCKET_WRAPPER_LIB ${SOCKET_WRAPPER_LOCATION} NAME)

configure_file(socket_wrapper.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc
  DESTINATION
    ${LIB_INSTALL_DIR}/pkgconfig
  COMPONENT
    pkgconfig
)

# cmake config files
configure_file(socket_wrapper-config-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake @ONLY)
configure_file(socket_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake @ONLY)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake
    DESTINATION
        ${CMAKE_INSTALL_DIR}/socket_wrapper
    COMPONENT
        devel
)

=== src/CMakeLists.txt ===
project(libsocket_wrapper C)

include_directories(${CMAKE_BINARY_DIR})
add_library(socket_wrapper SHARED socket_wrapper.c)

target_link_libraries(socket_wrapper ${SWRAP_REQUIRED_LIBRARIES})

install(
  TARGETS
    socket_wrapper
  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)

set_target_properties(
  socket_wrapper
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
)

# This needs to be at the end
if (POLICY CMP0026)
    cmake_policy(SET CMP0026 OLD)
endif()
get_target_property(SWRAP_LOCATION socket_wrapper LOCATION)
set(SOCKET_WRAPPER_LOCATION ${SWRAP_LOCATION} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
project(tests C)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMOCKA_INCLUDE_DIR}
)

set(TORTURE_LIBRARY torture)

# RFC862 echo server
add_executable(echo_srv echo_srv.c)
target_link_libraries(echo_srv ${SWRAP_REQUIRED_LIBRARIES})

add_library(${TORTURE_LIBRARY} STATIC torture.c)
target_link_libraries(${TORTURE_LIBRARY}
    ${CMOCKA_LIBRARY}
    ${SWRAP_REQUIRED_LIBRARIES})

set(SWRAP_TESTS
    test_ioctl
    test_echo_tcp_connect
    test_echo_tcp_socket_options
    test_echo_tcp_write_read
    test_echo_tcp_writev_readv
    test_echo_udp_sendto_recvfrom
    test_echo_udp_send_recv
    test_echo_udp_sendmsg_recvmsg)

if (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
    set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd)
endif (HAVE_STRUCT_MSGHDR_MSG_CONTROL)

foreach(_SWRAP_TEST ${SWRAP_TESTS})
    add_cmocka_test(${_SWRAP_TEST} ${_SWRAP_TEST}.c ${TORTURE_LIBRARY})

    if (OSX)
        set_property(
            TEST
                ${_SWRAP_TEST}
            PROPERTY
                ENVIRONMENT DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION})
    else ()
        set_property(
            TEST
                ${_SWRAP_TEST}
            PROPERTY
                ENVIRONMENT LD_PRELOAD=${SOCKET_WRAPPER_LOCATION})
    endif()
endforeach()

## socket wrapper-1.1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,8 +7,8 @@
 set(APPLICATION_NAME ${PROJECT_NAME})
 
 set(APPLICATION_VERSION_MAJOR "1")
-set(APPLICATION_VERSION_MINOR "0")
-set(APPLICATION_VERSION_PATCH "2")
+set(APPLICATION_VERSION_MINOR "1")
+set(APPLICATION_VERSION_PATCH "6")
 
 set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")
 
@@ -19,7 +19,7 @@
 #     Increment AGE. Set REVISION to 0
 #   If the source code was changed, but there were no interface changes:
 #     Increment REVISION.
-set(LIBRARY_VERSION "0.0.2")
+set(LIBRARY_VERSION "0.1.6")
 set(LIBRARY_SOVERSION "0")
 
 # where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
@@ -51,9 +51,10 @@
 add_subdirectory(src)
 
 if (UNIT_TESTING)
-  find_package(CMocka REQUIRED)
-  include(AddCMockaTest)
-  add_subdirectory(tests)
+    find_package(cmocka 0.4.1 REQUIRED)
+
+    include(AddCMockaTest)
+    add_subdirectory(tests)
 endif (UNIT_TESTING)
 
 # pkg-config file
@@ -82,3 +83,4 @@
         devel
 )
 
+add_subdirectory(doc)

## socket wrapper-1.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,20 @@
-project(socket_wrapper C)
+# Required cmake version
+cmake_minimum_required(VERSION 3.5.0)
+cmake_policy(SET CMP0048 NEW)
 
-# Required cmake version
-cmake_minimum_required(VERSION 2.8.5)
+# Specify search path for CMake modules to be loaded by include() 
+# and find_package()
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
+
+# Add defaults for cmake
+# Those need to be set before the project() call.
+include(DefineCMakeDefaults)
+include(DefineCompilerFlags)
+
+project(socket_wrapper VERSION 1.2.3 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
-
-set(APPLICATION_VERSION_MAJOR "1")
-set(APPLICATION_VERSION_MINOR "1")
-set(APPLICATION_VERSION_PATCH "6")
-
-set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")
 
 # SOVERSION scheme: CURRENT.AGE.REVISION
 #   If there was an incompatible interface change:
@@ -19,21 +23,15 @@
 #     Increment AGE. Set REVISION to 0
 #   If the source code was changed, but there were no interface changes:
 #     Increment REVISION.
-set(LIBRARY_VERSION "0.1.6")
+set(LIBRARY_VERSION "0.1.13")
 set(LIBRARY_SOVERSION "0")
 
-# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
-set(CMAKE_MODULE_PATH
-  ${CMAKE_SOURCE_DIR}/cmake/Modules
-)
-
 # add definitions
-include(DefineCMakeDefaults)
 include(DefinePlatformDefaults)
-include(DefineCompilerFlags)
-include(DefineInstallationPaths)
 include(DefineOptions.cmake)
 include(CPackConfig.cmake)
+include(CompilerChecks.cmake)
+include(GNUInstallDirs)
 
 # disallow in-source build
 include(MacroEnsureOutOfSourceBuild)
@@ -51,7 +49,7 @@
 add_subdirectory(src)
 
 if (UNIT_TESTING)
-    find_package(cmocka 0.4.1 REQUIRED)
+    find_package(cmocka 1.1.0 REQUIRED)
 
     include(AddCMockaTest)
     add_subdirectory(tests)
@@ -65,7 +63,7 @@
   FILES
     ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper.pc
   DESTINATION
-    ${LIB_INSTALL_DIR}/pkgconfig
+      ${CMAKE_INSTALL_LIBDIR}/pkgconfig
   COMPONENT
     pkgconfig
 )
@@ -78,7 +76,7 @@
         ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake
         ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake
     DESTINATION
-        ${CMAKE_INSTALL_DIR}/socket_wrapper
+        ${CMAKE_INSTALL_LIBDIR}/cmake/socket_wrapper
     COMPONENT
         devel
 )

## socket wrapper-1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 cmake_minimum_required(VERSION 3.5.0)
 cmake_policy(SET CMP0048 NEW)
 
-# Specify search path for CMake modules to be loaded by include() 
+# Specify search path for CMake modules to be loaded by include()
 # and find_package()
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
 
@@ -11,20 +11,29 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.2.3 LANGUAGES C)
+project(socket_wrapper VERSION 1.4.0 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
 
-# SOVERSION scheme: CURRENT.AGE.REVISION
+# SOVERSION scheme: MAJOR.MINOR.PATCH
 #   If there was an incompatible interface change:
-#     Increment CURRENT. Set AGE and REVISION to 0
+#     Increment MAJOR. Set MINOR and PATCH to 0
 #   If there was a compatible interface change:
-#     Increment AGE. Set REVISION to 0
+#     Increment MINOR. Set PATCH to 0
 #   If the source code was changed, but there were no interface changes:
-#     Increment REVISION.
-set(LIBRARY_VERSION "0.1.13")
-set(LIBRARY_SOVERSION "0")
+#     Increment PATCH.
+set(LIBRARY_VERSION_MAJOR 0)
+set(LIBRARY_VERSION_MINOR 4)
+set(LIBRARY_VERSION_PATCH 0)
+set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
+set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})
+
+set(NOOP_LIBRARY_VERSION_MAJOR 0)
+set(NOOP_LIBRARY_VERSION_MINOR 0)
+set(NOOP_LIBRARY_VERSION_PATCH 1)
+set(NOOP_LIBRARY_VERSION "${NOOP_LIBRARY_VERSION_MAJOR}.${NOOP_LIBRARY_VERSION_MINOR}.${NOOP_LIBRARY_VERSION_PATCH}")
+set(NOOP_LIBRARY_SOVERSION ${NOOP_LIBRARY_VERSION_MAJOR})
 
 # add definitions
 include(DefinePlatformDefaults)
@@ -68,6 +77,16 @@
     pkgconfig
 )
 
+configure_file(socket_wrapper_noop.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper_noop.pc @ONLY)
+install(
+  FILES
+    ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper_noop.pc
+  DESTINATION
+      ${CMAKE_INSTALL_LIBDIR}/pkgconfig
+  COMPONENT
+    pkgconfig
+)
+
 # cmake config files
 configure_file(socket_wrapper-config-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config-version.cmake @ONLY)
 configure_file(socket_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/socket_wrapper-config.cmake @ONLY)

=== tests/CMakeLists.txt ===
project(tests C)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMOCKA_INCLUDE_DIR}
)

set(TORTURE_LIBRARY torture)

# RFC862 echo server
add_executable(echo_srv echo_srv.c)
target_compile_options(echo_srv
                       PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -D_GNU_SOURCE)
target_link_libraries(echo_srv ${SWRAP_REQUIRED_LIBRARIES})
if (DEFINED DEFAULT_LINK_FLAGS)
    set_target_properties(echo_srv
                          PROPERTIES
                              LINK_FLAGS ${DEFAULT_LINK_FLAGS})
endif()

add_library(${TORTURE_LIBRARY} STATIC torture.c)
target_compile_options(${TORTURE_LIBRARY}
                       PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -D_GNU_SOURCE)
target_link_libraries(${TORTURE_LIBRARY}
    ${CMOCKA_LIBRARY}
    ${SWRAP_REQUIRED_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT})

add_library(swrap_fake_uid_wrapper SHARED swrap_fake_uid_wrapper.c)
target_compile_options(swrap_fake_uid_wrapper
                       PRIVATE
                           ${DEFAULT_C_COMPILE_FLAGS}
                           -D_GNU_SOURCE)
#target_include_directories(swrap_fake_uid_wrapper
#        PRIVATE ${CMAKE_BINARY_DIR} ${CMOCKA_INCLUDE_DIR})
set(SWRAP_FAKE_UID_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}swrap_fake_uid_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}")

set(SWRAP_THREADED_TESTS
    test_thread_sockets
    test_thread_echo_tcp_connect
    test_thread_echo_tcp_write_read
    test_thread_echo_tcp_sendmsg_recvmsg
    test_thread_echo_udp_send_recv)

set(SWRAP_TESTS
    test_ioctl
    test_tcp_listen
    test_tcp_dup2
    test_fcntl
    test_echo_tcp_connect
    test_echo_tcp_bind
    test_echo_tcp_socket_options
    test_echo_tcp_sendmsg_recvmsg
    test_echo_tcp_sendmmsg_recvmmsg
    test_echo_tcp_write_read
    test_echo_tcp_writev_readv
    test_echo_tcp_get_peer_sock_name
    test_echo_udp_sendto_recvfrom
    test_echo_udp_send_recv
    test_echo_udp_sendmsg_recvmsg
    test_swrap_unit
    test_max_sockets
    test_public_functions
    test_close_failure
    test_tcp_socket_overwrite
    test_syscall_uwrap
    ${SWRAP_THREADED_TESTS})

if (HAVE_STRUCT_MSGHDR_MSG_CONTROL)
    set(SWRAP_TESTS ${SWRAP_TESTS} test_sendmsg_recvmsg_fd test_echo_tcp_sendmsg_recvmsg_fd)
endif (HAVE_STRUCT_MSGHDR_MSG_CONTROL)

function(ADD_CMOCKA_TEST_ENVIRONMENT _TEST_NAME)
    if (CMAKE_BUILD_TYPE)
        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer")
            find_library(ASAN_LIBRARY
                         NAMES asan)
            if (NOT ASAN_LIBRARY)
                foreach(version RANGE 10 1)
                    if (NOT ASAN_LIBRARY)
                        find_library(ASAN_LIBRARY libasan.so.${version})
                    endif()
                endforeach()
            endif()
        endif()
    endif()

    if (ASAN_LIBRARY)
        list(APPEND PRELOAD_LIBRARIES ${ASAN_LIBRARY})
    endif()
    list(APPEND PRELOAD_LIBRARIES ${SWRAP_FAKE_UID_WRAPPER_LOCATION})
    list(APPEND PRELOAD_LIBRARIES ${SOCKET_WRAPPER_LOCATION})

    if (OSX)
        set(TORTURE_ENVIRONMENT "DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION}")
    else ()
        string(REPLACE ";" ":" _TMP_ENV "${PRELOAD_LIBRARIES}")
        set(TORTURE_ENVIRONMENT "LD_PRELOAD=${_TMP_ENV}")
    endif()

    if (CMAKE_BUILD_TYPE)
        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer" OR
            CMAKE_BUILD_TYPE_LOWER STREQUAL "threadsanitizer" OR
            CMAKE_BUILD_TYPE_LOWER STREQUAL "undefinedsanitizer")
            list(APPEND TORTURE_ENVIRONMENT "SOCKET_WRAPPER_DISABLE_DEEPBIND=1")
        endif()
    endif()

    set_property(TEST
                    ${_TEST_NAME}
                PROPERTY
                    ENVIRONMENT "${TORTURE_ENVIRONMENT}")
endfunction()

foreach(_SWRAP_TEST ${SWRAP_TESTS})
    add_cmocka_test(${_SWRAP_TEST}
                    SOURCES ${_SWRAP_TEST}.c
                    COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE
                    LINK_LIBRARIES ${TORTURE_LIBRARY} socket_wrapper_noop
                    LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
    add_cmocka_test_environment(${_SWRAP_TEST})
endforeach()

if (HELGRIND_TESTING)
    find_program(VALGRIND_EXECUTABLE valgrind)
    if (VALGRIND_EXECUTABLE)
        set(VALGRIND_HELGRIND_OPTIONS -v --trace-children=yes --tool=helgrind --error-exitcode=1 --read-var-info=yes --suppressions=${CMAKE_CURRENT_SOURCE_DIR}/helgrind.supp)

        foreach(_TEST ${SWRAP_THREADED_TESTS})
            set(_HELGRIND_TEST "helgrind_${_TEST}")

            add_test(NAME ${_HELGRIND_TEST} COMMAND ${VALGRIND_EXECUTABLE} ${VALGRIND_HELGRIND_OPTIONS} ${CMAKE_CURRENT_BINARY_DIR}/${_TEST})
            if (OSX)
                set_property(
                    TEST
                        ${_HELGRIND_TEST}
                    PROPERTY
                        ENVIRONMENT DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${SOCKET_WRAPPER_LOCATION})
            else ()
                set_property(
                    TEST
                        ${_HELGRIND_TEST}
                    PROPERTY
                        ENVIRONMENT LD_PRELOAD=${SOCKET_WRAPPER_LOCATION} SOCKET_WRAPPER_DISABLE_DEEPBIND=1)
            endif()
        endforeach()
    endif()
endif()

# test_fork_pthread
add_library(thread_deadlock SHARED thread_deadlock.c)
target_link_libraries(thread_deadlock ${CMAKE_THREAD_LIBS_INIT})
target_compile_options(thread_deadlock PRIVATE ${DEFAULT_C_COMPILE_FLAGS})

add_cmocka_test(test_fork_thread_deadlock
                SOURCES test_fork_thread_deadlock.c
                COMPILE_OPTIONS ${DEFAULT_C_COMPILE_FLAGS} -D_GNU_SOURCE
                LINK_LIBRARIES ${TORTURE_LIBRARY} thread_deadlock
                LINK_OPTIONS ${DEFAULT_LINK_FLAGS})
add_cmocka_test_environment(test_fork_thread_deadlock)

## socket wrapper-1.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Required cmake version
-cmake_minimum_required(VERSION 3.5.0)
+cmake_minimum_required(VERSION 3.10.0)
 cmake_policy(SET CMP0048 NEW)
 
 # Specify search path for CMake modules to be loaded by include()
@@ -11,7 +11,7 @@
 include(DefineCMakeDefaults)
 include(DefineCompilerFlags)
 
-project(socket_wrapper VERSION 1.4.0 LANGUAGES C)
+project(socket_wrapper VERSION 1.5.0 LANGUAGES C)
 
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
@@ -24,7 +24,7 @@
 #   If the source code was changed, but there were no interface changes:
 #     Increment PATCH.
 set(LIBRARY_VERSION_MAJOR 0)
-set(LIBRARY_VERSION_MINOR 4)
+set(LIBRARY_VERSION_MINOR 5)
 set(LIBRARY_VERSION_PATCH 0)
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})
